Index: NEMO/trunk/doc/latex/SI3/subfiles/chap_model_basics.tex
===================================================================
--- NEMO/trunk/doc/latex/SI3/tex_sub/chap_model_basics.tex	(revision 10146)
+++ NEMO/trunk/doc/latex/SI3/subfiles/chap_model_basics.tex	(revision 11015)
@@ -1,4 +1,4 @@
 
-\documentclass[../../tex_main/NEMO_manual]{subfiles}
+\documentclass[../main/SI3_manual]{subfiles}
 
 \begin{document}
@@ -41,6 +41,6 @@
 \begin{center}
 \vspace{0cm}
-\includegraphics[height=10cm,angle=-00]{../Figures/ice_scheme.png}
-\caption{Representation of the ice pack, using multiple categories with specific ice concentration ($a_l, l=1, 2, ..., L$), thickness ($h^i_l$), snow depth ($h^s_l$), vertical temperature and salinity profiles ($T^i_{kl}$, $S^{*}_{kl}$) and a single ice velocity vector ($\bm{u}$).}
+\includegraphics[height=10cm,angle=-00]{ice_scheme}
+\caption{Representation of the ice pack, using multiple categories with specific ice concentration ($a_l, l=1, 2, ..., L$), thickness ($h^i_l$), snow depth ($h^s_l$), vertical temperature and salinity profiles ($T^i_{kl}$, $S^{*}_{kl}$) and a single ice velocity vector ($\mathbf{u}$).}
 \label{ice_scheme}
 \end{center}
@@ -162,5 +162,5 @@
 %-------------------------------------------------------------------------------------------------------------------------
 
-We first present the essentials of the thickness distribution framework \citep{Thorndikeetal75}. Consider a given region of area $R$ centered at spatial coordinates $(\bm{x})$ at a given time $t$. $R$ could be e.g. a model grid cell. The ice thickness distribution $g(\mathbf{x},t, h)$ is introduced as follows:
+We first present the essentials of the thickness distribution framework \citep{Thorndikeetal75}. Consider a given region of area $R$ centered at spatial coordinates $(\mathbf{x})$ at a given time $t$. $R$ could be e.g. a model grid cell. The ice thickness distribution $g(\mathbf{x},t, h)$ is introduced as follows:
 \begin{linenomath}
 \begin{align}
@@ -184,5 +184,5 @@
 \begin{center}
 \vspace{0cm}
-\includegraphics[height=6cm,angle=-00]{../Figures/g_h.png}
+\includegraphics[height=6cm,angle=-00]{g_h}
 \caption{Representation of the relation between real thickness profiles and the ice thickness distribution function $g(h)$}
 \label{fig_g_h}
@@ -202,5 +202,5 @@
 \begin{linenomath}
 \begin{align}
-\frac{\partial a_l}{\partial t} = - \bm{\nabla} \cdot (a_l \mathbf{u}) + \Theta^a_l + \int_{H^*_{l-1}}^{H^*_l} dh \psi.
+\frac{\partial a_l}{\partial t} = - \mathbf{\nabla} \cdot (a_l \mathbf{u}) + \Theta^a_l + \int_{H^*_{l-1}}^{H^*_l} dh \psi.
 \label{eq:gt}
 \end{align}
@@ -211,6 +211,6 @@
 \begin{linenomath}
 \begin{align}
- A(\bm{x},t) &=\int_{0^+}^{\infty} dh \cdot g(h,\bm{x},t) \sim A_{ij} = \sum_{l=1}^L a_{ijl}, & \\
- V_i(\bm{x},t)&=\int_{0}^{\infty} dh \cdot g(h,\bm{x},t) \cdot h \sim V^i_{ij} = \sum_{l=1}^L v^i_{ijl}. & \\
+ A(\mathbf{x},t) &=\int_{0^+}^{\infty} dh \cdot g(h,\mathbf{x},t) \sim A_{ij} = \sum_{l=1}^L a_{ijl}, & \\
+ V_i(\mathbf{x},t)&=\int_{0}^{\infty} dh \cdot g(h,\mathbf{x},t) \cdot h \sim V^i_{ij} = \sum_{l=1}^L v^i_{ijl}. & \\
 \end{align}
 \end{linenomath}
@@ -228,12 +228,12 @@
 \begin{linenomath}
 \begin{align}
-m \frac{\partial \bm{u}} {\partial t} & = \bm{\nabla}\cdot\bm{\sigma} +A \left(\bm{\tau}_{a}+\bm{\tau}_{w}\right) - m f \bm{k} \times \bm{u} - m g \bm{\nabla}{\eta},
+m \frac{\partial \mathbf{u}} {\partial t} & = \mathbf{\nabla}\cdot\mathbf{\sigma} +A \left(\mathbf{\tau}_{a}+\mathbf{\tau}_{w}\right) - m f \mathbf{k} \times \mathbf{u} - m g \mathbf{\nabla}{\eta},
 \label{a}
 \end{align}
 \end{linenomath}
-where $m=\rho_i V_i + \rho_s V_s $ is the ice and snow mass per unit area, $\bm{u}$ is the ice velocity, $\bm{\sigma}$ is the internal stress tensor, $\bm{\tau}_a$ and $\bm{\tau}_w$ are the air and ocean stresses, respectively, $f$ is the Coriolis parameter, $\bm{k}$ is a unit vector pointing upwards, $g$ is the gravity acceleration and $\eta$ is the ocean surface elevation. The EVP approach used in LIM \citep{Bouillonetal13} gives the stress tensor as a function of the strain rate tensor $\dot{\bm{\epsilon}}$ and some of the sea ice state variables:
-\begin{linenomath}
-\begin{align}
-\bm{\sigma} & = \bm{\sigma} (\dot{ \bm{\epsilon}}, \text{ice state}).
+where $m=\rho_i V_i + \rho_s V_s $ is the ice and snow mass per unit area, $\mathbf{u}$ is the ice velocity, $\mathbf{\sigma}$ is the internal stress tensor, $\mathbf{\tau}_a$ and $\mathbf{\tau}_w$ are the air and ocean stresses, respectively, $f$ is the Coriolis parameter, $\mathbf{k}$ is a unit vector pointing upwards, $g$ is the gravity acceleration and $\eta$ is the ocean surface elevation. The EVP approach used in LIM \citep{Bouillonetal13} gives the stress tensor as a function of the strain rate tensor $\dot{\mathbf{\epsilon}}$ and some of the sea ice state variables:
+\begin{linenomath}
+\begin{align}
+\mathbf{\sigma} & = \mathbf{\sigma} (\dot{ \mathbf{\epsilon}}, \text{ice state}).
 \end{align}
 \end{linenomath}
@@ -245,5 +245,5 @@
 \end{align}
 \end{linenomath}
-including the effets of transport, thermodynamics ($\Theta^X$) and mechanical redistribution ($\Psi^X$). Solving these $jpl.(4+2.jpk)$ equations gives the temporal evolution of $\bm{u}$, $\bm{\sigma}$ and the rest of the global (extensive) variables listed in Table \ref{GVariables_table}.
+including the effets of transport, thermodynamics ($\Theta^X$) and mechanical redistribution ($\Psi^X$). Solving these $jpl.(4+2.jpk)$ equations gives the temporal evolution of $\mathbf{u}$, $\mathbf{\sigma}$ and the rest of the global (extensive) variables listed in Table \ref{GVariables_table}.
 
 \section{Ice Dynamics}
@@ -272,5 +272,5 @@
 \begin{center}
 \vspace{0cm}
-\includegraphics[height=6cm,angle=-00]{../Figures/yield_curve.png}
+\includegraphics[height=6cm,angle=-00]{yield_curve}
 \caption{Elliptical yield curve used in the VP rheologies, drawn in the space of the principal components of the stress tensor ($\sigma_1$ and $\sigma_2$).}
 \label{fig_yield}
@@ -383,5 +383,5 @@
 \begin{center}
 \vspace{0cm}
-\includegraphics[height=8cm,angle=-00]{../Figures/Thermal_properties.png}
+\includegraphics[height=8cm,angle=-00]{Thermal_properties}
 \caption{Thermal properties of sea ice vs temperature for different bulk salinities: brine fraction, specific enthalpy, thermal conductivity, and effective specific heat.}
 \label{fig_thermal_properties}