Index: NEMO/trunk/doc/latex/TOP/main/TOP_manual.bib
===================================================================
--- NEMO/trunk/doc/latex/TOP/main/TOP_manual.bib	(revision 11020)
+++ NEMO/trunk/doc/latex/TOP/main/TOP_manual.bib	(revision 11023)
@@ -9,5 +9,5 @@
 
 @ARTICLE{Armstrong_al_2002,
-  author =       {Armstrong, R. A. and Lee, C. and Hedges, J. I. and Honjo, S., and Wakeham, S. G.},
+  author =       {Armstrong, R. A. and Lee, C. and Hedges, J. I. and Honjo, S. and Wakeham, S. G.},
   title =        {A new, mechanistic model for organic carbon fluxes in the ocean based on the quantitative association of POC with ballast minarals},
   journal =      {Deep Sea Research Part II},
@@ -20,5 +20,5 @@
 
 @ARTICLE{Aumont_al_2015,
-  author =       {Aumont, O. and Eth\'e, C. and Tagliabue, A. and Bopp, L., and Gehlen, M.},
+  author =       {Aumont, O. and Eth\'e, C. and Tagliabue, A. and Bopp, L. and Gehlen, M.},
   title =        {PISCES-v2: an ocean biogeochemical model for carbon and ecosystem studies},
   journal =      {Geosciences Model Development},
@@ -30,5 +30,5 @@
 
 @ARTICLE{Bacastow_MaierReimer_1990,
-  author =       {Bacastow, R., and Maier-Reimer, E.},
+  author =       {Bacastow, R. and Maier-Reimer, E.},
   title =        {Ocean-circulation model of the carbon cycle},
   journal =      {Climate Dynamics},
@@ -57,5 +57,5 @@
 
 @ARTICLE{Danabasoglu_al_2014,
-  author =       {Danabasoglu, G., and Co-authors},
+  author =       {Danabasoglu, G. and Co-authors},
   title =        {Coordinated Ocean-ice Reference Experiments (CORE-II)},
   journal =      {Ocean Modelling},
@@ -72,5 +72,5 @@
   Ishida, A. and Joos, F. and Lindsay, K. and  Madec, G. and Maier-Reimer, E. and Marshall, J. and
   Matear, R. and Monfray, P. and Mouchet, A. and Plattner, G.-K. and Sarmiento, J. and
-  Schlitzer, R. and Slater, R. and Totterdell, I. and Weirig, M.-F. and Yamanaka, Y., and
+  Schlitzer, R. and Slater, R. and Totterdell, I. and Weirig, M.-F. and Yamanaka, Y. and
   Yool, A.},
   title =        {Evaluation of ocean model ventilation with CFC-11: comparison of 13 global ocean models},
@@ -84,5 +84,5 @@
 
 @TECHREPORT{Enting_al_1994,
-  author =       {Enting, I. G., and Wigley,  T. M. L. and Heimann, M.},
+  author =       {Enting, I. G. and Wigley,  T. M. L. and Heimann, M.},
   title =        {Future emissions and concentrations of carbon dioxide : Key Ocean/Atmosphere/Land Analyses},
   institution =  {CSIRO},
@@ -123,5 +123,5 @@
 
 @ARTICLE{Joos_al_1997,
-  author =       {Joos, F., and Orr, J. C. and Siegenthaler, U.},
+  author =       {Joos, F. and Orr, J. C. and Siegenthaler, U.},
   title =        {Ocean carbon transport in a box-diffusion versus a general circulation model},
   journal =      {Journal of Geophysical Research},
@@ -134,5 +134,5 @@
 
 @ARTICLE{Key_al_2004,
-  author =       {Key, R. M., and Kozyr, A. and Sabine, C. and Lee, K. and Wanninkhof, R. and Bullister, J. and Feely, R. and Millero, F. and Mordy, C. and Peng, T.-H.},
+  author =       {Key, R. M. and Kozyr, A. and Sabine, C. and Lee, K. and Wanninkhof, R. and Bullister, J. and Feely, R. and Millero, F. and Mordy, C. and Peng, T.-H.},
   title =        {A global ocean carbon climatology: Results from {GLODAP}},
   journal =      {Global Biogeochemical Cycles},
@@ -161,5 +161,5 @@
 
 @ARTICLE{Meunier_al_2014,
-  author =       {Meunier, C. L., Malzahn, A. M., and Boersma, M.},
+  author =       {Meunier, C. L., Malzahn, A. M. and Boersma, M.},
   title =        {A New Approach to Homeostatic Regulation: Towards a Unified View of Physiological and Ecological Concepts},
   journal =      {PLoS ONE},
@@ -172,5 +172,5 @@
 
 @ARTICLE{Monnin_al_2004,
-  author =       {Monnin, E., and {et al.} },
+  author =       {Monnin, E. and {et al.} },
   title =        {EPICA Dome C ice core high resolution Holocene and transition {CO$_2$} data},
   journal =      {Data contribution series \# 2004-055, IGBP PAGES/World Data Center for Paleoclimatology; NOAA/NCDC Paleoclimatology Program, Boulder, Colorado,U.S.A.},