Index: branches/UKMO/dev_r5518_GO6_fix_zemp_ice/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_fix_zemp_ice/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 11039)
+++ branches/UKMO/dev_r5518_GO6_fix_zemp_ice/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 11045)
@@ -184,5 +184,4 @@
    LOGICAL     ::   ln_usecplmask          !  use a coupling mask file to merge data received from several models
                                            !   -> file cplmask.nc with the float variable called cplmask (jpi,jpj,nn_cplmodel)
-   LOGICAL, PUBLIC ::   ln_fix_sea_ice_fluxes     ! Apply sea ice flux bug fixes (GMED#449)
 
    TYPE ::   DYNARR     
@@ -261,6 +260,5 @@
          &                  ln_usecplmask, nn_coupled_iceshelf_fluxes, ln_iceshelf_init_atmos,        &
          &                  rn_greenland_total_fw_flux, rn_greenland_calving_fraction, &
-         &                  rn_antarctica_total_fw_flux, rn_antarctica_calving_fraction, rn_iceshelf_fluxes_tolerance, &
-         &                  ln_fix_sea_ice_fluxes
+         &                  rn_antarctica_total_fw_flux, rn_antarctica_calving_fraction, rn_iceshelf_fluxes_tolerance
       !!---------------------------------------------------------------------
 
@@ -332,5 +330,4 @@
          WRITE(numout,*)'  nn_cplmodel                         = ', nn_cplmodel
          WRITE(numout,*)'  ln_usecplmask                       = ', ln_usecplmask
-         WRITE(numout,*)'  ln_fix_sea_ice_fluxes               = ', ln_fix_sea_ice_fluxes
          WRITE(numout,*)'  nn_coupled_iceshelf_fluxes          = ', nn_coupled_iceshelf_fluxes
          WRITE(numout,*)'  ln_iceshelf_init_atmos              = ', ln_iceshelf_init_atmos
@@ -1774,15 +1771,7 @@
          IF ( TRIM(sn_rcv_emp%clcat) == 'yes' ) THEN
             ! zemp_ice is the sum of frcv(jpr_ievp)%z3(:,:,1) over all layers - snow
-            IF ( ln_fix_sea_ice_fluxes ) THEN
-               zemp_ice(:,:) = - frcv(jpr_snow)%z3(:,:,1) * zicefr(:,:)
-            ELSE
-               zemp_ice(:,:) = - frcv(jpr_snow)%z3(:,:,1)
-            ENDIF
+            zemp_ice(:,:) = - frcv(jpr_snow)%z3(:,:,1) * zicefr(:,:)
             DO jl=1,jpl
-               IF ( ln_fix_sea_ice_fluxes ) THEN
-                  zemp_ice(:,:   ) = zemp_ice(:,:) + frcv(jpr_ievp)%z3(:,:,jl) * a_i_last_couple(:,:,jl)
-               ELSE
-                  zemp_ice(:,:   ) = zemp_ice(:,:) + frcv(jpr_ievp)%z3(:,:,jl)
-               ENDIF
+               zemp_ice(:,:   ) = zemp_ice(:,:) + frcv(jpr_ievp)%z3(:,:,jl) * a_i_last_couple(:,:,jl)
             ENDDO
             ! latent heat coupled for each category in CICE
Index: branches/UKMO/dev_r5518_GO6_fix_zemp_ice/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_fix_zemp_ice/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 11039)
+++ branches/UKMO/dev_r5518_GO6_fix_zemp_ice/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 11045)
@@ -395,9 +395,5 @@
          ELSE IF (ksbc == jp_purecpl) THEN
             DO jl=1,ncat
-               IF ( ln_fix_sea_ice_fluxes ) THEN
-                  ztmpn(:,:,jl)=qla_ice(:,:,jl)*a_i_last_couple(:,:,jl)
-               ELSE
-                  ztmpn(:,:,jl)=qla_ice(:,:,jl)*a_i(:,:,jl)
-               ENDIF
+               ztmpn(:,:,jl)=qla_ice(:,:,jl)*a_i_last_couple(:,:,jl)
             ENDDO
 	 ELSE
@@ -412,9 +408,5 @@
 !  Convert to GBM
             IF (ksbc == jp_flx .OR. ksbc == jp_purecpl) THEN
-               IF ( ln_fix_sea_ice_fluxes ) THEN
-                  ztmp(:,:) = botmelt(:,:,jl)*a_i_last_couple(:,:,jl)
-               ELSE
-                  ztmp(:,:) = botmelt(:,:,jl)*a_i(:,:,jl)
-               ENDIF
+               ztmp(:,:) = botmelt(:,:,jl)*a_i_last_couple(:,:,jl)
             ELSE
                ztmp(:,:) = botmelt(:,:,jl)
@@ -425,9 +417,5 @@
 !  Convert to GBM
             IF (ksbc == jp_flx .OR. ksbc == jp_purecpl) THEN
-               IF ( ln_fix_sea_ice_fluxes ) THEN
-                  ztmp(:,:) = (topmelt(:,:,jl)+botmelt(:,:,jl))*a_i_last_couple(:,:,jl) 
-               ELSE
-                  ztmp(:,:) = (topmelt(:,:,jl)+botmelt(:,:,jl))*a_i(:,:,jl)
-               ENDIF
+               ztmp(:,:) = (topmelt(:,:,jl)+botmelt(:,:,jl))*a_i_last_couple(:,:,jl) 
             ELSE
                ztmp(:,:) = (topmelt(:,:,jl)+botmelt(:,:,jl))